''' Lutz Ifers WinAPI-Tutorial
'''
''' Kapitel 1.2 - "Erzeugen eines ersten Fensters"

#include "windows.bi"
const ProgrammName = "Erzeugen eines Fensters"

declare function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT

dim as WNDCLASS	windowclass
with windowclass
    .style         =  CS_HREDRAW or CS_VREDRAW
    .lpfnWndProc   =  ProcPtr(Fenster)
    .cbClsExtra    =  0
    .cbWndExtra    =  0
    .hInstance     =  GetModuleHandle(NULL)
    .hCursor       =  LoadCursor(NULL, IDC_ARROW)
    .hIcon         =  LoadIcon(NULL, IDI_APPLICATION)
    .hbrBackground =  GetStockObject(WHITE_BRUSH)
    .lpszClassName =  StrPtr(ProgrammName)
    .lpszMenuName  =  NULL
end with
RegisterClass @windowclass

dim as HWND	MeinFenster = CreateWindow(_
    ProgrammName, "Titelzeile", WS_OVERLAPPEDWINDOW,_
    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,_
    NULL, NULL, GetModuleHandle(NULL), NULL)

ShowWindow   MeinFenster, SW_NORMAL
UpdateWindow MeinFenster

dim as MSG Nachricht
do while GetMessage(@Nachricht, NULL, 0, 0) <> 0
    DispatchMessage  @Nachricht
loop
end Nachricht.wParam

function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
    
    if message = WM_DESTROY then
        PostQuitMessage 0
        return 0
    else 
        return DefWindowProc(hWnd, message, wParam, lParam)
    end if
end function
