''' Lutz Ifers WinAPI-Tutorial
'''
''' Kapitel 2.3 - "Textausgabe"

#include "windows.bi"
const ProgrammName = "Textausgabe"
const sText =     "Lorem ipsum dolor sit amet, consectetur adipisicing elit, "+_
    "sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut en"+_
    "im ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut al"+_
    "iquip ex ea commodo consequat."+chr(13,10)+"Duis aute irure dolor in rep"+_
    "rehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatu"+_
    "r."+chr(13,10)+"Excepteur sint occaecat cupidatat non proident, sunt in "+_
    "culpa qui officia deserunt mollit anim id est laborum."+chr(13,10,13,10)+_
    "Lorem ipsum dolor sit amet, consectetur adipisicing elit, "+_
    "sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut en"+_
    "im ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut al"+_
    "iquip ex ea commodo consequat."+chr(13,10)+"Duis aute irure dolor in rep"+_
    "rehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatu"+_
    "r."+chr(13,10)+"Excepteur sint occaecat cupidatat non proident, sunt in "+_
    "culpa qui officia deserunt mollit anim id est laborum."

declare function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT

dim as WNDCLASS	wcMeinFenster
with wcMeinFenster
    .style         =  CS_HREDRAW or CS_VREDRAW
    .lpfnWndProc   =  ProcPtr(Fenster)
    .cbClsExtra    =  0
    .cbWndExtra    =  0
    .hInstance     =  GetModuleHandle(NULL)
    .hCursor       =  LoadCursor(NULL, IDC_ARROW)
    .hIcon         =  LoadIcon(NULL, IDI_APPLICATION)
    .hbrBackground =  GetStockObject(WHITE_BRUSH)
    .lpszClassName =  StrPtr(ProgrammName)
    .lpszMenuName  =  NULL
end with
RegisterClass @wcMeinFenster

dim as HWND	hMeinFenster = CreateWindow(_
    ProgrammName, "Titelzeile", WS_OVERLAPPEDWINDOW,_
    CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,_
    NULL, NULL, GetModuleHandle(NULL), NULL)

ShowWindow   hMeinFenster, SW_NORMAL
UpdateWindow hMeinFenster

dim as MSG msg
do while getmessage(@msg, NULL, 0, 0) <> 0
    DispatchMessage  @msg
loop
end msg.wParam

function Fenster(byval hWnd as HWND, byval message as UINTEGER,_
    byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
    
    static as RECT rect
    
    select case message
        case WM_DESTROY
            PostQuitMessage 0
            return 0
            
        case WM_SIZE
            rect.right = LOWORD(lParam)
            rect.bottom = HIWORD(lParam)
            return 0

           
        case WM_PAINT
            const sUeberschrift = "berschrift"
            dim as PAINTSTRUCT pnt
            dim as RECT textrect
            dim as HDC hDC = BeginPaint(hWnd, @pnt)
                SelectObject hDC, GetStockObject(LTGRAY_BRUSH)
                TextOut hDC, 10, 10, sUeberschrift, len(sUeberschrift)
                
                with textrect
                    .top    = 30
                    .left   = 0
                    .right  = rect.right
                    .bottom = 50
                end with
                
                Rectangle hDC, textrect.left, textrect.top, textrect.right, textrect.bottom
                DrawText hDC, sUeberschrift, len(sUeberschrift), @textrect, DT_CENTER
                
                with textrect
                    .top    = 60
                    .left   = 10
                    .right  = rect.right - 10
                    .bottom = 120
                end with
                
                Rectangle hDC, textrect.left-1, textrect.top-1, textrect.right+1, textrect.bottom+1
                DrawText hDC, sText, len(sText), @textrect, 0
                
                with textrect
                    .top    = 130
                    .left   = 10
                    .right  = rect.right - 10
                    .bottom = 170
                end with
                
                Rectangle hDC, textrect.left-1, textrect.top-1, textrect.right+1, textrect.bottom+1
                DrawText hDC, sText, len(sText), @textrect, DT_SINGLELINE
                
                with textrect
                    .top    = 180
                    .left   = 10
                    .right  = rect.right - 10
                    .bottom = rect.bottom - 10
                end with
                
                Rectangle hDC, textrect.left-1, textrect.top-1, textrect.right+1, textrect.bottom+1
                DrawText hDC, sText, len(sText), @textrect, DT_WORDBREAK
                
                EndPaint(hWnd, @pnt)
            return 0
    end select
    return DefWindowProc(hWnd, message, wParam, lParam)
end function
